    /*
 * 3D Engine 
 * clipping.h: 
 * Based on pikuma.com 3D software renderer in C
 * Copyright (c) 2021 986-Studio. All rights reserved.
 *
 * Created by Manoël Trapier on 11/03/2021.
 */

#ifndef THREEDENGINE_SOURCE_INCLUDE_CLIPPING_H
#define THREEDENGINE_SOURCE_INCLUDE_CLIPPING_H

#include <vector.h>

/***********************************************************************************************************************
 * Data types
 **********************************************************************************************************************/
enum
{
    TOP_PLANE = 0,
    RIGHT_PLANE,
    BOTTOM_PLANE,
    LEFT_PLANE,
    NEAR_PLANE,
    FAR_PLANE,

    /* Keep at the end */
    TOTAL_PLANES
};

typedef struct plane_t
{
  vec3_t point;
  vec3_t normal;
} plane_t;

/***********************************************************************************************************************
 * Prototypes
 **********************************************************************************************************************/
void initFrustumPlanes(double fov, double aspectRation, double zNear, double zFar);

#endif /* THREEDENGINE_SOURCE_INCLUDE_CLIPPING_H */
